
# include <graphics.h>


 #include <stdlib.h>
 #include <alloc.h>
 #include <stdio.h>

 #include <conio.h>

 #include "bmptest/bmp_defs.h"  // definitions of bmp header structs;
 
 /**********************************
  ******  Initialize Settings  *****
  *********************************/

 void init()
 {
   /* request auto detection */
    int gdriver = DETECT, gmode, errorcode;

    /* initialize graphics mode */
    initgraph(&gdriver, &gmode, "");

    /* read result of initialization */
    errorcode = graphresult();

   if (errorcode != grOk)  /* an error occurred */
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);             /* return with error code */
   }

  };


int writebmptofile(int left, int top, int right, int bottom, char* pictname)
	{
   // saves the image within the boundries as
   // a windows 16 color (4 bit) BMP file.
	  BmpHeader head;
	  HeaderInfo Info;
	  int width;
	  
	  unsigned char c; // used to store pixel data.
	  int j, i;  // iterators for going over the screen image:
	  unsigned char * scanline; //used to store a full line of pixels;
	  
	  FILE * fp;

  // Initialize headers:
	  head.ImageType[0]='B'; head.ImageType[1]= 'M';
	  head.FileSize = 0; // We'll update this after writing the file;
	  head.Reserved1=0; head.Reserved2=0;
	  head.DataOffset = (unsigned long)(sizeof(head)+sizeof(Info)+(sizeof(RGBColors[0])*16));
	  Info.HeaderSize = 40;
	  Info.Height = bottom-top;
	  Info.NumOfPlanes = 1;
	  Info.BitsPerPixel = 4;
	  Info.Width = right-left;
	  if ((Info.Width * Info.BitsPerPixel / 8)%32)
	  width = (((Info.Width * Info.BitsPerPixel / 8)/32)+1)*32;
	  Info.CompMethod = 0;
	  Info.BmpSize = 0; //Don't really need this data;
	  Info.HorzResolution = getmaxx();
	  Info.VertResolution = getmaxy();
	  Info.ColorsNumber = 16;
	  Info.SigColors = 0;

	  fp = fopen(pictname,"wb");
	  if(fp==NULL)
	  return 0;

    // Write the headers:
	  fwrite(&head, sizeof(head), 1, fp);
	  fwrite(&Info, sizeof(Info), 1, fp);

     // Write the pallette (defined above);
	  fwrite(RGBColors, sizeof(RGBColors[0]), 16, fp);

     //SCAN and WRITE PICTURE:
	  scanline = (unsigned char *) calloc (width+1, sizeof(unsigned char));
	  if(scanline==NULL)
		  return 0;
	  for (j=Info.Height; j>=0; j--)
	   {
	    int k=0; i=0;
	    while (i<=Info.Width)
		{
		c = (unsigned char)getpixel(i+left, j+top);
		scanline[k] = c<<4;
		c = (unsigned char)getpixel(i+left+1, j+top);
		scanline[k] = scanline[k]|c;
		k++;
		i=i+2;  //we read two pixels each iteration.
		}
	    for (;k<width; k++)
		 scanline[k] = 0x00; // pad the end of the line.
	    fwrite(scanline, sizeof(unsigned char), width, fp);
	    }
	  free (scanline);
	  fseek(fp, 0, SEEK_END);   // Goto the end of the file;
						   // We should already be there;
	  head.FileSize = ftell(fp);// Record the real file size.
	  fseek(fp, 0, SEEK_SET);   // Go to the begining;
	  fwrite(&head, sizeof(head), 1, fp);  // Write the correct data;
	  Info.Width = 2*width;
	  fwrite(&Info, sizeof(Info), 1, fp);
	  fclose(fp);
	  return 1;
	 }



int readbmpfromfile(int left, int top, char* pictname)
	{
	  // Reading a BMP file; sometimes works:-)
      int j, i;
	  BmpHeader head;
	  HeaderInfo Info;
	  RGBPalette ImgColors[16];
	  struct palettetype pal;
	  unsigned char * scanline;
	  int k=0;
	  unsigned char c=0;
	  FILE * fp;
	  fp = fopen(pictname,"rb");
	  if(fp==NULL)
		  return 0;
     //READ HEADERS:
	  fread(&head, sizeof(head), 1, fp);
	  fread(&Info, sizeof(Info), 1, fp);
      if(Info.BitsPerPixel!=4)  // This isn't a 16 color bmp we can read;
	   { fclose(fp); return 0; };

    //Set Pallette: (Use with care; can mess up the screen completely);
	  fread(ImgColors, sizeof(ImgColors[0]), Info.ColorsNumber, fp);
	  getpalette(&pal);
	  for (i=0;i<Info.ColorsNumber;i++)
		setrgbpalette(pal.colors[i], ImgColors[i].red, ImgColors[i].green, ImgColors[i].blue);

     //READ and DRAW PICTURE:
	  fseek(fp, head.DataOffset, SEEK_SET);
	  scanline = (unsigned char *) calloc (Info.Width/2+1, sizeof(unsigned char));
	  for (j=Info.Height; j>=0; j--)
	   {
-	    fread(scanline, sizeof(unsigned char), Info.Width/2, fp);
	    c=0; k=0;
	    for (i=0;i<=Info.Width;i+=2){
		    c = (scanline[k] | 0x00) >>4;

		    putpixel(i+left, j+top, c);
		    c = (scanline[k] | 0xF0) & 0x0F;
		    putpixel(i+1+left, j+top, c);
		    k++;
		 }
	    }
	  free (scanline);
	  fclose(fp);
     return 1;
	 }

	 /********************************
	 *****  Actual Main Program  *****
	 ********************************/

 void main()
  {
   int h, w, j;
   int col;
   printf("Enter a color (0-15):");
   scanf("%d", &col);
   init();
   if (col>15) col=15;
   if (col<0) col=0;
   /* DRAW SOMETHING: */
   setfillstyle(SOLID_FILL,col);
      bar(0,0,getmaxx(), getmaxy());
      setfillstyle(SOLID_FILL,8);
       bar(10, 10, 200, 170);
       setfillstyle(SOLID_FILL,5);
       bar(80,90,123,245);
       setfillstyle(SOLID_FILL,13);
       bar(180,190,300,423);
       setfillstyle(6,13);
       bar(300,300,getmaxx()-4,getmaxy()-3);
       rectangle(0, 200,452,380);
   /* SAVE IT: */
       writebmptofile(0, 0, getmaxx(), getmaxy(), "mypic.bmp");
	 getch();
       restorecrtmode();
       printf("Screen is %d wide, %d high\n", getmaxx(), getmaxy());
       printf("Press any key to return to graphics mode, then press \"r\" to restore picture:");
       getch();
       /* return to graphics mode */
setgraphmode(getgraphmode());
       h=getch();
       if (h=='r')
	  {
	/* BRING BACK THE PICTURE: */
	   readbmpfromfile(0, 0, "mypic.bmp");
	    };
       getch();
  closegraph();
}
