// .BMP HEADERS DEFINED: 


 // BmpHeader:

typedef struct {
	char ImageType[2];  // Always equal to: BM
	unsigned long FileSize; // size of file in bytes;
	unsigned int Reserved1; // always 0;
	unsigned int Reserved2; // always 0;
	unsigned long DataOffset; // sizeof(BmpHeader) + sizeof (HeaderInfo) + sizeof (RGBPalette[16]) = 118;
      } BmpHeader;
//---------------------------

  // HeaderInfo:

typedef struct {
	unsigned long HeaderSize;    // sizeof(HeaderInfo) = 40 bytes;
	unsigned long Width;         // width in pixels;
	unsigned long Height;        // height in pixels;
	unsigned int NumOfPlanes;    // always 1;
	unsigned int BitsPerPixel;   // 4 in 16 color images;
	unsigned long CompMethod;    // 0 if uncompressed;
	unsigned long BmpSize;       // Size of image in bytes; If uncompressed, set to 0;
	unsigned long HorzResolution;// horizontal resolution;
	unsigned long VertResolution;// vertical resolution;
	unsigned long ColorsNumber;  // number of colors;
	unsigned long SigColors;     // number of most important colors; Set to 0;
} HeaderInfo;
//----------------------------

// RGBPalette:

typedef struct {
	 unsigned char blue;
	 unsigned char green;
	 unsigned char red;
	 unsigned char reserved; // always 0;
} RGBPalette;
//----------------------------


// Intialize 16 color array:

RGBPalette RGBColors[16] = {
			 {0,0,0,0},       //Black
			 {170,85,0,0},    //Blue
			 {0,170,85,0},    //Green
			 {170,170,0,0},   //Cyan
			 {0,85,170,0},    //Red
			 {170,0,170,0},   //Magenta
			 {0,90,170,0},    //Brown
			 {170,170,170,0}, //Light Gray
			 {85,85,85,0},    //Dark Gray
			 {255,0,0,0},     //Light Blue
			 {0,255,0,0},     //Light Green
			 {255,255,0,0},   //Light Cyan
			 {0,85,255,0},    //Light Red
			 {255,0,255,0},   //Light Magenta
			 {0,255,255,0},   //Yellow
			 {255,255,255,0}  //White
		     };


/* */

